protected/models/Ticket.php
<?php

/**
 * This is the model class for table "ticket".
 *
 * The followings are the available columns in table 'ticket':
 * @property integer $id_ticket
 * @property integer $id_version
 * @property integer $id_type
 * @property integer $id_priority
 * @property integer $id_status
 * @property integer $id_assignee
 * @property integer $id_post
 * @property string $commit
 *
 * The followings are the available model relations:
 * @property Version $version
 * @property TicketType $type
 * @property TicketPriority priority
 * @property TicketStatus status
 * @property User $assignee
 * @property Post $post
 * @property Ticket $parent
 * @property Ticket[] $children
 */
class Ticket extends CActiveRecord
{
    
    public $searchTitle, $searchProject;
    
	/**
	 * Returns the static model of the specified AR class.
	 * @param string $className active record class name.
	 * @return Ticket the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'ticket';
	}
    
    function init()
    {
        $this->id_priority = TicketPriority::findByName('normal')->id_ticket_priority;
        $this->id_status = TicketStatus::findByName('new')->id_ticket_status;
    }

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('id_version, id_type, id_priority, id_status', 'required'),
			array('id_parent, id_version, id_type, id_priority, id_status, id_assignee',
                  'numerical', 'integerOnly'=>true),
            array('id_parent','compare','compareAttribute'=>'id_ticket',
                  'operator'=>'!=', 'allowEmpty'=>true,
                  'message'=>'Cannot be parent of itselt'),
			array('commit', 'length', 'max'=>40),
            array('id_post','safe'), // handled in controller
			// The following rule is used by search().
			// Please remove those attributes that should not be searched.
			array('searchProject, searchTitle, id_ticket,
                  id_version, id_type, id_priority, id_status,
                  id_assignee, id_post, commit', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
			'version' => array(self::BELONGS_TO, 'Version', 'id_version'),
			'type' => array(self::BELONGS_TO, 'TicketType', 'id_type'),
			'priority' => array(self::BELONGS_TO, 'TicketPriority', 'id_priority'),
			'status' => array(self::BELONGS_TO, 'TicketStatus', 'id_status'),
			'assignee' => array(self::BELONGS_TO, 'User', 'id_assignee'),
			'post' => array(self::BELONGS_TO, 'Post', 'id_post'),
			'parent' => array(self::BELONGS_TO, 'Ticket', 'id_parent'),
			'children' => array(self::HAS_MANY, 'Ticket', 'id_parent'),
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
            'id_parent' => 'Parent',
			'id_version' => 'Version',
			'id_type' => 'Type',
			'id_priority' => 'Priority',
			'id_status' => 'Status',
			'id_assignee' => 'Assigned to',
			'id_post' => 'Post',
            'id_ticket' => 'Ticket Id',
			'commit' => 'Commit',
            'searchTitle' => 'Title',
            'searchProject' => 'Project',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 * @return CActiveDataProvider the data provider that can return the models based on the search/filter conditions.
	 */
	public function search($id_project=null)
	{
		// Warning: Please modify the following code to remove attributes that
		// should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('t.id_version',$this->id_version);
		$criteria->compare('t.id_type',$this->id_type);
		$criteria->compare('t.id_priority',$this->id_priority);
		$criteria->compare('t.id_status',$this->id_status);
		$criteria->compare('t.id_assignee',$this->id_assignee);
		$criteria->compare('t.id_post',$this->id_post);
		$criteria->compare('t.commit',$this->commit,true);
        
        $criteria->with = array('post','version','priority','status');
        $criteria->compare('post.title',$this->searchTitle,true);
        
        if ( $id_project != null )
        {
            $criteria->compare('version.id_project',$id_project);
        }
        else
        {
            $criteria->compare('version.id_project',$this->searchProject);
            
        }


        $sort = new CSort();
        $sort->attributes = array(
            'id_type',
            'id_status',
            'searchTitle'=>array(
                'asc'=>'post.title ASC',
                'desc'=>'post.title DESC',
            ),
            'id_priority'=>array(
                'asc'=>'priority.weight desc',
                'desc'=>'priority.weight asc',
            ),
            'id_status'=>array(
                'asc'=>'status.weight asc',
                'desc'=>'status.weight desc',
            ),
        );
        $sort->multiSort = true;
        $sort->defaultOrder = 'status.weight asc, priority.weight desc';
        
		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
            'sort' => $sort,
		));
	}
    
    function full_title()
    {
        return $this->post->title." - #".$this->id_ticket;
    }
}

protected/controllers/MainController.php
<?php

class MainController extends Controller
{
	public function actionIndex()
	{
        $this->redirect(array('page/index'));
	}

	/**
	 * This is the action to handle external exceptions.
	 */
	public function actionError()
	{
        $this->renderError();
	}

    function getPageTitle()
    {
        if ( isset($this->page_title) )
            return $this->page_title;
        
        return Yii::app()->name ." | ". ucfirst($this->action->id);
    }
    
    function actionCss($sheet)
    {
        header('Content-Type: text/css');
        $this->renderPartial('/css/'.$sheet); // todo: check minification performance
        //echo CssMin::minify($this->renderPartial('/css/'.$sheet,null,true));
    }
    
    
    function actionSearch()
    {
        $this->set_return_url($_REQUEST);
        $search = new SearchForm;
        if ( isset($_GET['q']) )
            $search->term = $_GET['q'];
        if ( isset($_REQUEST['SearchForm']) )
            $search->attributes = $_REQUEST['SearchForm'];
        $this->render('search',array('search'=>$search));
    }
    
    function actionTest()
    {
        $this->render('test');
    }
}

protected/controllers/TicketController.php
<?php

class TicketController extends Controller
{
    /**
     * @return array action filters
     */
    public function filters()
    {
        return array(
            'accessControl', // perform access control for CRUD operations
        );
    }

    /**
     * Specifies the access control rules.
     * This method is used by the 'accessControl' filter.
     * @return array access control rules
     */
    public function accessRules()
    {
        return array(
            array('allow',
                'actions'=>array('index','view','project','autocomplete','error'),
                'users'=>array('*'),
            ),
            array('allow',
                  'actions'=>array('comment'),
                  'expression' => '$user->has_role("guest")',
            ),
            array('allow',
                  'actions'=>array('create','editPost'),
                  'expression' => '$user->has_role("user")',
            ),
            array('allow',
                  'actions'=>array('update','move'),
                  'expression' => '$user->has_role("contributor")',
            ),
            array('allow',
                  'expression' => '$user->has_role("admin")',
            ),
            array('deny',  // deny all users
                'users'=>array('*'),
            ),
        );
    }
    
    function init()
    {        
        parent::init();
        Yii::app()->errorHandler->errorAction=$this->id.'/error';
    }
    function actionError()
    {
        $this->breadcrumbs = array('Tickets'=>array('ticket/index'),'Error');
        $this->setDefaultActions();
        $this->renderError();
    }
    
    function setDefaultActions()
    {
        
        foreach(Project::model()->findAll() as $project )
            $this->link_actions []= array(
                'label'=>'New Ticket for '.$project->name,
                'url'=>array('ticket/create', 'project'=>$project->id_project));
    }


    /**
     * Displays a particular model.
     * @param integer $id the ID of the model to be displayed
     */
    public function actionView($id)
    {
        $this->set_return_url();
            
        $tick = $this->loadModel($id);
        
        $edit = $tick->post->do_request_reply('ticket');
        if ( $edit != null && !$edit->hasErrors() )
            $this->redirect(array('ticket/view','id'=>$id));        
        
        $this->render('view',array(
            'model'=>$tick,
        ));
    }

    /**
     * Creates a new model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     */
    public function actionCreate($project)
    {
        $project = Project::model()->findByPk($project);
        if ( $project == null )
            throw new CHttpException(404,'The requested project does not exists');
        
        $model= new Ticket;
        $post = new Post;
        $edit = new Edit;

        $this->performAjaxValidation(array($model,$post,$edit));

        if(isset($_POST['Ticket']))
        {
            $model->attributes=$_POST['Ticket'];
            
            if(isset($_POST['Edit']['text']))
                $edit->text = $_POST['Edit']['text'];
                
            if(isset($_POST['Post']))
                $post->attributes = $_POST['Post'];
            
            $post->id_type = PostType::findByName('ticket')->id_post_type;
                
            if( $post->validate() && $edit->validate('text') && $model->validate() )
            {
                $post->save(false);
                $model->id_post = $post->id_post;
                $model->save(false);
                $edit->id_post = $post->id_post;
                $edit->id_user = Yii::app()->user->id;
                $edit->save(false);
                $this->redirect(array('view','id'=>$model->id_ticket));
            }
        }

        $this->render('create',array(
            'model'=>$model,
            'post' => $post,
            'edit' => $edit,
            'project' => $project,
        ));
    }

    protected function ticket_edit_text(Ticket$old,Ticket$new)
    {
        
        $text = "Updated ticket:\n";
        
        if ( $old->id_status != $new->id_status )
            $text .= "Status: {$old->status->name} -> {$new->status->name}\n";
        if ( $old->id_priority != $new->id_priority )
            $text .= "Status: {$old->priority->name} -> {$new->priority->name}\n";
        if ( $old->id_type != $new->id_type )
            $text .= "Status: {$old->type->name} -> {$new->type->name}\n";
        if ( $old->id_version != $new->id_version )
            $text .= "Version: ".
                $old->version->project->name." ".$old->version->name." -> ".
                $new->version->project->name." ".$new->version->name."\n";
        
        
        if ( $old->id_parent != $new->id_parent )
        {
            $text .= "Parent: ";
            if ( $old->id_parent != null )
                $text .= $old->parent->full_title();
            else
                $text .= "(none)";
            $text .= " -> ";
            if ( $new->id_parent != null )
                $text .=  $new->parent->full_title();
            else
                $text .= "(none)";
            $text .= "\n";
        }
        
        if ( $old->id_assignee != $new->id_assignee )
        {
            $text .= "Assigned to: ";
            if ( $old->id_assignee != null )
                $text .= $old->assignee->name;
            else
                $text .= "(nobody)";
            $text .= " -> ";
            if ( $new->id_assignee != null )
                $text .= $new->assignee->name;
            else
                $text .= "(nobody)";
            $text .= "\n";
        }
        
        if ( $old->commit != $new->commit )
        {
            $text .= "Commit: $old->commit -> $new->commit\n";
        }

        return $text;
    }
    
    /**
     * Updates a particular model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id the ID of the model to be updated
     */
    public function actionUpdate($id)
    {
        $model=$this->loadModel($id);
        
        $post = $model->post;
        $edit = new Edit('autofill');

        $this->performAjaxValidation(array($model,$post));
        
        if(isset($_POST['Ticket']))
        {
            $model->attributes=$_POST['Ticket'];
            
            if(isset($_POST['Edit']))
                $edit->attributes = $_POST['Edit'];
                
            if(isset($_POST['Post']))
                $post->attributes = $_POST['Post'];
            
            $post->id_type = PostType::findByName('ticket')->id_post_type;
                
            if( $post->validate() && $model->validate() )
            {
                $edit->text =
                    $this->ticket_edit_text($this->loadModel($id),$model)."\n".
                    $edit->text;
                $post->save(false);
                $model->id_post = $post->id_post;
                $model->save(false);
                
                $post->do_reply($edit->text,Yii::app()->user,'ticket');
                
                $this->redirect(array('view','id'=>$model->id_ticket));
            }
        }

        $this->render('update',array(
            'model'=>$model,
            'edit'=>$edit,
            'post'=>$post,
        ));
    }

    function actionIndex()
    {
        $this->set_return_url();
        $this->setDefaultActions();
        $model=new Ticket('search');
        $model->unsetAttributes();  // clear any default values
        if(isset($_GET['Ticket']))
            $model->attributes=$_GET['Ticket'];

        $this->render('index',array(
            'model'=>$model,
        ));
    }

    public function actionProject($id)
    {
        $this->set_return_url();
        $project = Project::model()->findByPk($id);
        if ( $project == null )
            throw new CHttpException(404,'The requested project does not exists');
        
        $model=new Ticket('search');
        $model->unsetAttributes();  // clear any default values
        if(isset($_GET['Ticket']))
            $model->attributes=$_GET['Ticket'];

        $this->render('project',array(
            'model'=>$model,
            'project'=>$project,
        ));
    }

    /**
     * Returns the data model based on the primary key given in the GET variable.
     * If the data model is not found, an HTTP exception will be raised.
     * @param integer $id the ID of the model to be loaded
     * @return Ticket the loaded model
     * @throws CHttpException
     */
    public function loadModel($id)
    {
        $model=Ticket::model()->findByPk($id);
        if($model===null)
            throw new CHttpException(404,'The requested ticket does not exist.');
        return $model;
    }

    /**
     * Performs the AJAX validation.
     * @param Ticket $model the model to be validated
     */
    protected function performAjaxValidation($model)
    {
        if(isset($_POST['ajax']) && $_POST['ajax']==='ticket-form')
        {
            echo CActiveForm::validate($model);
            Yii::app()->end();
        }
    }
    
    function actionAutocomplete($term)
    {
        $matches = Yii::app()->db->createCommand()
            ->select('concat(post.title," - #",ticket.id_ticket) as value,
                      ticket.id_ticket as id')
            ->from('ticket')
            ->join('post','post.id_post = ticket.id_post')
            ->where('concat(post.title," - #",cast(ticket.id_ticket as char))
                    like :term', array('term'=>"%$term%"))
            ->limit(10)
            ->order('id_ticket desc')
            ->queryAll();
        
        echo json_encode ( $matches );
    }
    
    function actionComment($id)
    {
        $post = Post::model()->findByPk($id);
        if($post===null)
            throw new CHttpException(404,'The requested comment does not exist.');

protected/views/ticket/_details.php
<?php


function children_links(Ticket $model)
{
    $l = array();
    foreach($model->children as $c)
    {
        $l []= CHtml::link($c->full_title(),
                            array('ticket/view','id'=>$c->id_ticket));
    }
    return implode(", ",$l);
}



$this->widget('zii.widgets.CDetailView', array(
	'data'=>$model,
	'attributes'=>array(
		'version.project.name:text:Project',
		'version.name:text:Version',
		'type.name:text:Type',
		'priority.name:text:Priority',
		'status.name:text:Status',
        array(
            'label'=>'Parent',
            'type'=>'html',
            'value'=>!isset($model->parent) ? null :
                CHtml::link($model->parent->full_title(),
                            array('ticket/view','id'=>$model->id_parent) )
        ),
        array(
            'label'=>'Children',
            'type'=>'html',
            'value'=>empty($model->children) ? null : children_links($model) 
        ),
		'assignee.name:text:Assigned to',
		'commit',
	),
));

protected/views/ticket/_form.php
<?php
/* @var $this TicketController */
/* @var $model Ticket */
/* @var $edit Edit */
/* @var $post Post */
/* @var $project Project */
/* @var $form CustomForm */
?>

<div class="form">
<?php
$form = $this->beginWidget('CustomForm', array(
	'id'=>'ticket-form',
    'model'=>$model
));

    echo $form->errorSummary($edit)."\n";
    echo $form->errorSummary($post)."\n";

    echo '<div class="main-form">';
    echo $form->textRow($post,'title');
    echo $form->textAreaRow($edit,'text');
    echo '</div>';

    echo '<div class="options-form" >';
    
    echo "<div class='row'>
            <label>Project</label>
            <span class='inactive'>$project->name</span>
        </div>";
    
    echo $form->autoDropDownRow('id_version','Version','id_version','name',
                array('condition'=>'id_project=:idp',
                      'params'=>array('idp'=>$project->id_project),
                      'order'=>'name desc',
                ) );
    echo $form->autoDropDownRow('id_type','TicketType', 'id_ticket_type');
    echo $form->autoDropDownRow('id_priority','TicketPriority',
                                'id_ticket_priority');
    echo $form->autoDropDownRow('id_status','TicketStatus','id_ticket_status');

    $avail_user=CHtml::listData(User::model()->findAll('id_role=1'),
                                'id_user','name');
    $avail_user['']='Not assigned';
    echo $form->beginRow($model,'id_assignee');
    echo $form->labelEx($model,'id_assignee');
    echo $form->dropDownList($model,'id_assignee',$avail_user);
    echo $form->error($model,'id_assignee');
    echo $form->endRow();

    echo $form->autoTextRow('commit',array('size'=>40,'maxlength'=>40));
    
    echo $form->autoAutoCompleteRow('id_parent','ticket/autocomplete',
            isset($model->parent) ? 
                $model->parent->full_title() :
                (
                    isset($_POST['Ticket_id_parent_autocomplete']) ?
                        $_POST['Ticket_id_parent_autocomplete'] :
                        ''
                )
        );
    
    echo '</div>';
    
    echo $form->submitRow($model->isNewRecord ? 'Create' : 'Save');

$this->endWidget();

?>

</div><!-- form -->

protected/views/ticket/create.php
<?php
/* @var $this TicketController */
/* @var $model Ticket */

$this->breadcrumbs=array(
	'Tickets'=>array('index'),
    $project->name =>
                array('project','id'=>$project->id_project),
    'Create'
);
?>

<h2 class="title">Create Ticket</h2>

<?php echo $this->renderPartial('_form', array(
            'model'=>$model,
            'post' => $post,
            'edit' => $edit,
            'project' => $project
        )); ?>

protected/views/ticket/edit_post.php
<?php
/** @var $form CustomForm */

$this->pageTitle = Yii::app()->name." | Ticket | Edit | ".$post->title;

$this->breadcrumbs = array(
    'Tickets' => array('ticket/index'),
    $top->title => array('ticket/view','id'=>$top->ticket->id_ticket),
    'Edit Comment'
);

$form = $this->beginWidget('CustomForm',array(
    'model'=>$edit,
    'method'=>'post',
    'id' => 'edit-post',
));

echo $form->autoTextAreaRow('text');

echo $form->submitRow('Save');

$this->endWidget();

protected/views/ticket/index.php
<?php
/* @var $this TicketController */
/* @var $model Ticket */

$this->breadcrumbs = array (
    'Tickets'
);
    
?>

<h2 class="title">Tickets</h2>

<?php

$this->widget('DynamicPageGridView', array(
    'id'=>'ticket-grid',
    'dataProvider'=>$model->search(),
    'filter'=>$model,
    'cssFile'=>CHtml::normalizeUrl(array('main/css','sheet'=>'gridview')),
    'columns'=>array(
        array(
            'class' => 'CDataColumn',
            'name' => 'searchTitle',
            'type'=>'html',
            'value' => 'CHtml::link($data->post->title,
                                    array("ticket/view","id"=>$data->id_ticket))',
        ),
        array(
            'class'=>'CDataColumn',
            'name'=>'searchProject',
            'type'=>'html',
            'filter'=>CustomForm::drop_down('Project','id_project'),
            'value'=>'CHtml::link($data->version->project->name,
                    array("ticket/project","id"=>$data->version->id_project))',
        ),
        array(
            'class'=>'CDataColumn',
            'name'=>'id_type',
            'filter'=>CustomForm::drop_down('TicketType','id_ticket_type'),
            'value'=>'$data->type->name',
            'cssClassExpression'=>'"ticket-".$data->type->name',
        ),
        array(
            'class'=>'CDataColumn',
            'name'=>'id_priority',
            'filter'=>CustomForm::drop_down('TicketPriority','id_ticket_priority'),
            'value'=>'$data->priority->name',
            'cssClassExpression'=>'"ticket-".$data->priority->name',
        ),
        array(
            'class'=>'CDataColumn',
            'name'=>'id_status',
            'filter'=>CustomForm::drop_down('TicketStatus','id_ticket_status'),
            'value'=>'$data->status->name',
            'cssClassExpression'=>'"ticket-".$data->status->name',
        ),
        'assignee.name:text:Assigned to',
    ),
));

?>

protected/views/ticket/move.php
<?php
/* @var $this TicketController */
/* @var $model Ticket */
/* @var $form CustomForm */

$this->breadcrumbs=array(
	'Tickets'=>array('index'),
    $model->version->project->name =>
                array('project','id'=>$model->version->id_project),
	$model->post->title=>array('view','id'=>$model->id_ticket),
    'Move'
);

$this->pageTitle = Yii::app()->name . " | Ticket | " . $model->post->title;


$this->link_actions []= array('label'=>'Create New Ticket',
                              'url'=>array('ticket/create',
                                    'project'=>$model->version->id_project));

$this->link_actions []= array(
        'label' => 'View Ticket',
        'url' => array('ticket/view', 'id'=>$model->id_ticket)
    );

$this->link_actions []= array(
        'label' => 'Update Ticket',
        'url' => array('ticket/update', 'id'=>$model->id_ticket)
    );
?>

<h2 class="title">Move Ticket </h2>

<?php
$this->renderPartial('_details',array('model'=>$model));

$form = $this->beginWidget('CustomForm', array(
    'model'=>$model
));

$versions = Version::model()->findAll(array(
    'order'=>'id_project, name desc',
    'condition' => 'id_project != :idp',
    'params' => array('idp'=>$model->version->id_project),
));
$droplist = array();
foreach ( $versions as $v )
{
    $droplist[$v->id_version] = $v->project->name." ".$v->name;
}
echo CHtml::label('New Project/Version:','to',array('class'=>'inline')).' ';
echo CHtml::dropDownList('to',$model->id_version,$droplist).' ';
echo CHtml::submitButton('Move');
$this->endWidget();

protected/views/ticket/project.php
<?php
/* @var $this TicketController */
/* @var $model Ticket */


$this->breadcrumbs = array (
    'Tickets'=>array('index'),
    $project->name
);

$this->pageTitle = Yii::app()->name." | Tickets for ".$project->name;

$this->link_actions []= array('label'=>'Create Ticket',
                              'url'=>array('ticket/create',
                                           'project'=>$project->id_project));
    
?>

<h2 class="title">Tickets</h2>

<?php $this->widget('DynamicPageGridView', array(
    'id'=>'ticket-grid',
    'dataProvider'=>$model->search($project->id_project),
    'filter'=>$model,
    'cssFile'=>CHtml::normalizeUrl(array('main/css','sheet'=>'gridview')),
    'columns'=>array(
        array(
            'class' => 'CDataColumn',
            'name' => 'searchTitle',
            'type'=>'html',
            'value' => 'CHtml::link($data->post->title,
                                    array("ticket/view","id"=>$data->id_ticket))',
        ),
        array(
            'class'=>'CDataColumn',
            'header'=>'Project',
            'value'=>'$data->version->project->name',
        ),
        array(
            'class'=>'CDataColumn',
            'name'=>'id_version',
            'filter'=>CustomForm::drop_down('Version','id_version','name',
                        array('condition'=>'id_project=:idp',
                                  'params'=>array('idp'=>$project->id_project),
                                  'order'=>'name desc',
                            )
                        ),
            'value'=>'$data->version->name',
        ),
        array(
            'class'=>'CDataColumn',
            'name'=>'id_type',
            'filter'=>CustomForm::drop_down('TicketType','id_ticket_type'),
            'value'=>'$data->type->name',
            'cssClassExpression'=>'"ticket-".$data->type->name',
        ),
        array(
            'class'=>'CDataColumn',
            'name'=>'id_priority',
            'filter'=>CustomForm::drop_down('TicketPriority','id_ticket_priority'),
            'value'=>'$data->priority->name',
            'cssClassExpression'=>'"ticket-".$data->priority->name',
        ),
        array(
            'class'=>'CDataColumn',
            'name'=>'id_status',
            'filter'=>CustomForm::drop_down('TicketStatus','id_ticket_status'),
            'value'=>'$data->status->name',
            'cssClassExpression'=>'"ticket-".$data->status->name',
        ),
        'assignee.name:text:Assigned to',
    ),
)); ?>

protected/views/ticket/update.php
<?php
/* @var $this TicketController */
/* @var $model Ticket */

$this->breadcrumbs=array(
	'Tickets'=>array('index'),
    $model->version->project->name =>
                array('project','id'=>$model->version->id_project),
	$model->post->title=>array('view','id'=>$model->id_ticket),
	'Update',
);

$this->link_actions []= array('label'=>'Create New Ticket',
                              'url'=>array('ticket/create',
                                    'project'=>$model->version->id_project));

$this->link_actions []= array('label'=>'View Ticket',
                    'url'=>array('ticket/view','id'=>$model->id_ticket));

?>

<h2 class="title"><?php
    echo "Update Ticket ".$model->full_title();
?></h2>

<?php echo $this->renderPartial('_form', array(
            'model'=>$model,
            'post' => $post,
            'edit' => $edit,
            'project' => $model->version->project
        )); ?>

protected/views/ticket/view.php
<?php
/* @var $this TicketController */
/* @var $model Ticket */

$this->breadcrumbs=array(
	'Tickets'=>array('index'),
    $model->version->project->name =>
                array('project','id'=>$model->version->id_project),
	$model->post->title,
);

$this->pageTitle = Yii::app()->name . " | Ticket | " . $model->post->title;


$this->link_actions []= array('label'=>'Create New Ticket',
                              'url'=>array('ticket/create',
                                    'project'=>$model->version->id_project));

?>

<h2 class="title"><?php
    echo $model->full_title();
?></h2>

<?php

if ( Yii::app()->user->has_role('contributor') )
{
    $edit_url = array('ticket/update', 'id'=>$model->id_ticket);
    $this->link_actions []= array(
        'label' => 'Update Ticket',
        'url' => $edit_url
    );
    
    $this->link_actions []= array(
        'label' => 'Move Ticket',
        'url' => array('ticket/move', 'id'=>$model->id_ticket)
    );
    
    echo '<div class="edit-post">'.CHtml::link('Update Ticket Status',$edit_url).'</div>';
}

$this->renderPartial('_details',array('model'=>$model));

$model->post->full_render();

foreach($model->post->children as $comment)
{
    $comment->full_render();
}

$model->post->reply_form('Add comment');

?>